#!/bin/sh

install_to_dir="/Library/Audio/Plug-Ins/HAL/"
install_name="GreatdyPlugAudio.driver"
temp_path="/tmp/tmp-greatdy-usdye"
src_dir=$(dirname "$0")
new_src_dir="$2"
Daemon_name="GreatdyAudioPlugInDaemon"
Daemon_Dir="/Library/Application Support/Greatdy/LaunchDaemons"
Daemon_Plist="com.greatdy.audioPlugInDriver.startup.plist"
Daemon_Plist_Dir="/Library/LaunchDaemons"

function uninstall_old_kext_files(){
    kextunload /System/Library/Extensions/ComputerAudioCapture.kext
    rm -rf /System/Library/Extensions/ComputerAudioCapture.kext

    kextunload /Library/Extensions/ComputerAudioCapture.kext
    rm -rf /Library/Extensions/ComputerAudioCapture.kext
}

function install_old(){
    uninstall_old_kext_files

    rm -rf "${temp_path}"
    mkdir -p "${temp_path}"

    cp -r "${src_dir}/ComputerAudioCapture.kext" "${temp_path}"
    if [ -d "${new_src_dir}/ComputerAudioCapture.kext" ] && ! [ -d "${temp_path}/ComputerAudioCapture.kext"]
    then
        cp -r "${new_src_dir}/ComputerAudioCapture.kext" "${temp_path}"
    fi

    chown -R root:wheel "${temp_path}/ComputerAudioCapture.kext"

    mkdir -p "/Library/Extensions"
    cp -rfp "${temp_path}/ComputerAudioCapture.kext" "/Library/Extensions/"
    rm -rf "${temp_path}"

    kextload /Library/Extensions/ComputerAudioCapture.kext
    exit $?
}
function install(){
    uninstall_old_kext_files

    rm -rf "${temp_path}"
    mkdir -p "${temp_path}"
    cp -rf "${src_dir}/${install_name}" "${temp_path}"
    chown -R root:wheel "${temp_path}/${install_name}"

    mkdir -p "${install_to_dir}"
    cp -rfp "${temp_path}/${install_name}" "${install_to_dir}"
    rm -rf "${temp_path}"

    mkdir -p "${Daemon_Dir}"

#    echo "copy Daemon files"
#cp "${src_dir}/${Daemon_name}" "${Daemon_Dir}"
#    cp "${src_dir}/${Daemon_Plist}" "${Daemon_Plist_Dir}"

    killall "${Daemon_name}"
    killall -9 "coreaudiod"

#    launchctl load "${Daemon_Plist_Dir}/${Daemon_Plist}"

}
function uninstall_old(){
    rm -rf "${install_to_dir}/${install_name}"
    rm "${Daemon_Dir}/${Daemon_name}"
    rm "${Daemon_Plist_Dir}/${Daemon_Plist}"

    uninstall_old_kext_files
}
function uninstall(){
    uninstall_old

    killall "${Daemon_name}"
    killall -9 "coreaudiod"
}
function run_service()
{
    case "$1" in
        "install")
            install
            exit $?;
            ;;
        "install_old")
            install_old
            exit $?;
            ;;
        "uninstall")
            uninstall
            exit $?;
            ;;
        "uninstall_old")
            uninstall_old
            exit $?;
            ;;
        **)
            echo "Error: Unknown action '$1'"
            exit 1;
    esac
}

run_service "$1"
